/* 
        Nak.h

	MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
	X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)

	codeshimarinwin maslβŸ򸵤Yamahata
	ޤ
*/
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>

#ifdef MITSHM
#include <sys/ipc.h>
#include <sys/shm.h>
#include <X11/extensions/XShm.h>
#endif

#include "MmsConst.h"
#include "MaslInputStream.h"

#ifndef nak_h
#define nak_h
class Nak
{
  //variables  
#ifdef TEST_NAK
public:
#else
protected:
#endif
  unsigned char nakId;//1byte:ak5ΤɤηfileAK5_{NORM,DIFF}[_FAST]
  unsigned int dataSize;//data礭θsize byteNak dataͭ롣
  int left,top,right,bottom;//2bytex4:save area
  unsigned char* nakData;//dataƬؤpointer
  //constructϲdataΤؤ(header)Ѳʤ

  //n֤
  static int signOf (int n)
    {
      if (n>0)
	return 1;
      if (n<0)
	return -1;
      return 0;
    };

  //methods
  //private:
public:
  Nak (MaslInputStream& maslIs,const unsigned char mmsNakId);
  Nak ();//CellAheadä˲⤷ʤ
  friend class NakAhead;
  virtual ~Nak ();
protected:
  virtual void extractNak2Vram (const unsigned char* const nakData,
				unsigned char* imageData,
				const int x=0,const int y=0);
  // NakExtract롼
  inline unsigned short Nak::getNibble(const unsigned char*& nakData,
				       unsigned short& nibble)
    // ˥֥Υǡ¸礽ѡ
    // ;ä˥֥¸
    // BYTE*& nakData ǡθɤǤؤΥݥ󥿤λ
    // unsigned short& nibble			˥֥¸
    {
      unsigned short b = (nibble == 255)? (*nakData) & 0x0f : nibble;
      nibble = (nibble == 255)? (*nakData++) >> 4 : 255;
      return b;
    }

  
public:
  virtual void extractNak2Vram (unsigned char* const imageData,
				const int x=0,const int y=0)
    {extractNak2Vram (nakData,imageData,x,y);};
  void putImage (Display* const display,Visual* const visual,
		 const Drawable drawable,const GC gc,
		 unsigned char* const imageData,const int lengthOfData,
		 const unsigned char palette2Pixel[NUM_OF_COLORS],
		 const int left,const int top);
  

//////////////////////////////////////////////virtual vramؿ
public:
  static void moveRect (unsigned char* const imageData,
			const int srcLeft,const int srcTop,
			const int destLeft,const int destTop,
			const int width,const int height);
  static void orMoveRect (unsigned char* const imageData,
			  const int srcLeft,const srcTop,
			  const int destLeft,const int destTop,
			  const int width,const int height,
			  const int shift);
  static void zoom (unsigned char* const imageData,
		    const int srcLeft,const int srcTop,
		    const int destLeft,const int destTop,
		    const int srcWidth,const int srcHeight,
		    const int destWidth,const int destHeight,
		    const int transparentFlag=0,const int transparentColor=0);
  static void drawBox (unsigned char* const imageData,
		       const int left,const int top,
		       const int right,const int bottom,
		       const unsigned char color);
  static void setPoint (unsigned char* const imageData,
			const int x,const int y,const unsigned char color);
  static int getPoint (unsigned char* const imageData,
		       const int x,const int y);
  static void setPointWord (unsigned char* const imageData,
			    const int x,const int y,
			    const unsigned int wordColor);
  static int getPointWord (unsigned char* const imageData,
			   const int x,const int y);
};
#endif//nak_h
