/* 
        MaslAudio.h

        MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
        X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)
*/


#include <assert.h>
#include <sys/time.h>

#include "audio.h"

#ifndef maslaudio_h
#define maslaudio_h

struct SAMPLE_DATA
{
  unsigned char* data;
  int size;
  Bool isLoop;
};

class MaslAudio:public Audio
{
  ///////////////////////////////////////////////////////////PCMΰ٤class
private:
  static char* isAudioWriting;//=NULL;//write٤PCM dataͭ뤫
  //(ʤBoolͤ8ޤǤʤ餽줾bitɽ)
  /* *isAudioWriting!=0 */
  static char* isAudioWaiting;//=NULL;//PCMκλԤ򤷤Ƥ뤫
  /* *isAudioWaiting!=0λԤ򤷤Ƥ롣*/
  static SAMPLE_DATA sampleData;//PCMdata
  static SAMPLE_DATA oldSampleData;//PCMdataκǽФƤ
  //sampleData.size=-1λƤʤ
  static SAMPLE_DATA queSampleData;//ߺPCMλ˺򳫻Ϥ롣
  //sampleData.data=NULL,sampleData.size=-1λԤäƤdata̵
  static int queChannel;
  static int fragmentSize;//audio bufferfragment size
  static timeval intervalOfWritingAudioData;//PCM񤭹ߤλֳִ
  
  static unsigned char* nullSound;//=NULL;//̵data

#ifdef no_sigaction
  //⤷ʤ
#else
  static struct sigaction sigAction;//signal handlerѡ
#endif

public:
  //MaslAudioν
  static void prepareMaslAudio (char* const mmsIsAudioWriting,
				char* const mmsIsAudioWaiting);
  //classȤ٤򤹤
  //playAudio()򤷤ޤ
  //audio deviceopen˸ƤӽФƲ

  static void playAudio (const SAMPLE_DATA pcmData,const int channel=-1);
  //PCMޤ
  //channel=-1λϤɤchannelǺ뤫ꡣ
  //ʲ3ĤmethodplayAudio()timerߤǼ¸٤ɬס
  static void queAudioData (const SAMPLE_DATA pcmData,const int channel=-1);
  //ߺPCMλˤdata
  //Ƥʤͥꤷ̵뤵ޤ

private:
  static void writeAudioData (int sig);//ºݤPCMmethod
  static void setAudioTimerOn ();
  //writeAudioData ()Ƥְ٤signal򤹤

public:
  static void offAudioTimer ();//signal
  ///////////////////////////////////////////////////PCMΰ٤method
  static Bool setSampleRate (const long rate);//rateꤷޤ
  //λPCMߤޤ
  static void stopAudio (const int channel);
  //channelǻꤵ줿PCMκߤ
  //ߤν
  static void resetAudio ();//PCMߤޤ
private:
  static void resetAudioVariable ();//
  static void resetQueData ();
};

#endif //maslaudio_h
