/* 
        MmsWindow.h

        MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
        X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)
*/

#include <iostream.h>
#include <stdio.h>
#include <string.h>
#include <X11/keysym.h>

#ifdef MITSHM
#include <sys/ipc.h>
#include <sys/shm.h>
#include <X11/extensions/XShm.h>
#endif

#include "MaslXImage.h"

#ifndef mms_window_h
#define mms_window_h

///class MMSWidowɬפvariablesmethods
//classϤ٤class variablesmethodsʤ
//long???(pixelͤμ뷿) palette2Pixel[256];
//palette->pixelѴԤʤ٤
//private color cellʤɬ̵ɡ
//ޤλͤƤ
#define NUM_OF_WINDOW 8
class MmsWindow
{
#ifdef TEST_NAK
public:
#else
private:
#endif
  GraphicMode graphicMode;
  Display* display;//Xdisplay
  int screen;//screenֹ
  Visual* visual;//visual class
  GC gc;//GC
  int depth;//Xdepth
  Window window;//ɽwindow
  //unsigned char palette2Pixel[NUM_OF_COLORS];
  unsigned long palette2Pixel[NUM_OF_COLORS];//palette
  MaslXImage* ximage;//windowɽ˻ѤXImage¤Ρ
  char* imageData;//ximage->data
  int windowLeft;//XPutImageimageɽݤoffset
  int windowTop;//windowɽ롣
  int windowWidth;
  int windowHeight;
  inline void mmsXPutImage (MaslXImage* mmsXImage)
    {
      mmsXImage->XPutImage (window,gc,0,0,windowLeft,windowTop,
			    windowWidth,windowHeight);
    }
  
  MaslXImage* ximageOfVirtualVram;//virtual vramɽ뤿XImage¤Ρ
  char* imageDataOfVirtualVram;//xiamgeOfVirtualVram->data
  Window windowOfVirtualVram;//virtual vramɽ뤿window

  ///////////320x240 line mode or 320x200 line modeѴ٤ʪ
  MaslXImage* ximageOf2x0LineMode;//礹뤿˻ѤXImage¤
  char* imageDataOf2x0LineMode;//ximageOf2x0LineMode->data
  void allocXimageOf2x0LineMode ();//ximageOf2x0LineModeݤ뤿Υ᥽å

  XMMS_OPTION* const xmmsOption;

  //mmswindowФƤι¤Ρ
  class WINDOW
  {
  public:
    int vramX;//ž(vram)Xɸ
    int vramY;//ž(vram)Yɸ
    int virtualVramX;//ž(virtual vram)Xɸ
    int virtualVramY;//ž(virtual vram)Yɸ
    int width;//virtual vramǤwindowwidth
    int height;//virtual vramǤwindowhegit
    //windowsize==(0,0)λĤƤ롣
    WINDOW ():
      vramX (0),vramY (0),
      virtualVramX (0),virtualVramY (0),
      width (0),height (0)
      {/* do nothing */};
    void resetVariable ()
      {//ѿ뤿Υ᥽å
	vramX=0;
	vramY=0;
	virtualVramX=0;
	virtualVramY=0;
	width=0;
	height=0;
      };
  };
  WINDOW virtualWindow[NUM_OF_WINDOW];
public:
  void setWindowSize (int x1,int y1,int x2,int y2,int n=0);
  //mmswindow礭ꤹ
  void moveWindow (int x,int y,int n=0);
  //mmswindowΰ֤ꤹ
  void setGraphicMode (const GraphicMode mmsGraphicMode);
  //graphic modeꤹ᥽å
public:
  MmsWindow (Display* mmsDisplay,int mmsScreen,
	     Visual* mmsVisual,GC mmsGc,int mmsDepth,
	     Window mmsWindow,
	     unsigned long mmsPalette2Pixel[NUM_OF_COLORS],
	     XMMS_OPTION* mmsXmmsOption);
  ~MmsWindow ();
  void updateWindow (const unsigned char* const mmsImageData);
  //̤method
  void putImage (const unsigned char* const mmsImageData);
  void updateWindow (){putImage ();};//̤κmethod
  void putImage ();
  void putImageOfVirtualWindow (const unsigned char* const mmsImageData);
private:
  void putImage320x200 ();
  void putImage640x400 ();
  void putImage320x240 ();
  void putImage640x480 ();
  //줬MMSºݤ˲dataäpixelͤѴơw
  //indowɽmethod
  //gmode 0 - 320*200,1 - 640*400,2 - 320*240,3 - 640*480.ɽ
  //ͤäƤ줾modeˤäơximageѴmethodƤǤȤXPutImage
  //imageDatamethodѰդƸƤӽФ
/*
  320x200->XImage
  640x400->XImage
  320x240->XImage
  640x480->XImage
  Ѵmethod
  window size640x480˸ꤷƤheight400λϾ岼20dotĤ
  
*/
  void drawVirtualWindowFrame ();//virtual windowɤ˳Ƥ뤫ºݤ
  //ɽƤwindowĹɽ롣

};
#endif //mms_window_h
