/* 
        Pcm.h

	MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
	X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)

        codeshimarincode򸵤YamahataʪǤ

	Open Sound System verion Copyright (c)1997 Yamahata Isaku (ISA-9)
        Sun OS 4 version Copyright (c) 1997   (hibi@is.s.u-tokyo.ac.jp)
*/
#include <iostream.h>
#include <stdio.h>

#include "MaslInputStream.h"
#include "MaslAudio.h"

#ifndef pcm_h
#define pcm_h

#define ADPTABLESIZE 49//ADPCM->PCMѴ

class Pcm
{
  //variables
#if defined (TEST_NAK)|defined (TEST_AK5)
public:
#else 
private:
#endif
  const unsigned char type;//==1,3 adpcmData(IMA ADPCM 4bit)
                           //==0,2 unsigned linear 8bit
  char fileName[17];//file name
  int PcmRate;//Pcm rate
  unsigned int sizeOfAdpcm;//pkn datasize
  unsigned char* adpcmData;//pcm dataؤpointer
  unsigned int sizeOfU8;//adpcmDatau8Ѵsize
  unsigned char* u8Data;//adpcmDatalinear unsigned 8bitѴ

#if defined sunos4
  int  device16pr;
#endif //defined sunos4

  //ADPCM->unsigned 8 bit Ѵ
  short adp_table[ADPTABLESIZE];//кtable
  short now;//sample
  short adp;//Ǥкtable
  void calcSub (unsigned char);

  /////////////////////////////////methods
private:
  //pcmLoad (FILE* fp);
  void adpcm2U8 ();//98IMA PCM 4bitlinear unsigned 8 bit formatѴ롣

#if defined ULAW 
  unsigned char  st_linear_to_ulaw( int  sample );
  void U82ulaw ();
#else defined(LEANER8)||defined(LINEAR16)
  void U82linear ();
#endif //defined ULAW

public:
  Pcm (unsigned char mmsType,MaslInputStream& maslIs);
  ~Pcm ();
  void play ();
  void play (const int channel,const Bool isLoop=False);
  //channel=-1λchannelưꡣ
  void que (const int channel,const Bool isLoop=False);
  int getPcmRate () const { return PcmRate;};
  const char* const getFileName () const {return fileName;};
  char getType () const {return type;};
  int getSize () const {return sizeOfAdpcm;};
};
#endif //pcm_h

