/* 
        extractNak.cc

	MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
	X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)

	codeshimarinwin maslβŸΤ򸵤Yamahata
	ޤ
*/

#include "Nak.h"
void Nak::extractNak2Vram (const unsigned char* const nakData,
			   unsigned char* imageData,
			   const int x=0,const int y=0)
  // unsigned char* nakData ǡΥɥ쥹(Ƭ32ХȤξޤ)
  // unsigned char* imageData VRAMΥɥ쥹
  // int mmsOffset VRAMФ륪եå( y * 640 + x )
{
  const int backtrk[]=
  {
    2, 4, 8, 16, 638, 639, 640, 641,
    642, 1278, 1279, 1280, 1281, 1282, 2560, 5120
  };
  
  unsigned short nibble=255;// ¸˥֥(255=¸ʤ)

  const unsigned char* const lpBuffer1=nakData;// Хåե
  const unsigned char* const lpBuffer2=nakData+16;// Хåե
  const unsigned char* nakDataSrc=nakData+32;// ǡ
  imageData+=x+y*VIRTUAL_VRAM_SIZE_X;//Ϥޤ󤸤ʤʤ
  //ޤºݤưƤߤʤʬʤɡ
  unsigned char* imageDataStart=imageData;

  unsigned short cmd;
  short c=0;
  for (;;)
    {
      cmd=*nakDataSrc++;
      if (cmd<208)
	{// ̤ξ꤫ñ̤ʣ
	  //208=13*16ա
	  unsigned short subcmd=cmd%13;
	  unsigned short stlen;
	  switch (subcmd)
	    {
	    case 8:
	      stlen=getNibble (nakDataSrc,nibble)*2+9;
	      break;
	    case 9:
	      stlen=getNibble (nakDataSrc,nibble)*2+10;
	      break;
	    case 10:
	      stlen=(*nakDataSrc++)*2+41;
	      break;
	    case 11:
	      stlen=(*nakDataSrc++)*2+42;
	      break;
	    case 12:
	      //stlen=*((unsigned short*)nakDataSrc);
	      //nakDataSrc += 2;
	      stlen=*nakDataSrc++;
	      stlen+=(*(nakDataSrc++) << 8);
	      break;
	    default:
	      stlen=subcmd+1;
	      break;
	    }

	  /*
	    unsigned short* wp=(unsigned short*)(imageData-backtrk[cmd/13]);
	    for (int i=0;i<stlen;i++)
	    {
	    *((unsigned short*)imageData)=*wp++;
	    imageData+=2;
	    }
	    */
	  unsigned char* wp=imageData-backtrk[cmd/13];
	  for (int i=0;i<stlen*2;i++)
	    *imageData++=*wp++;

	  continue;
	}
      if (cmd<238)
	{
	  // ɥåȤʣ̤ʤ ( cmd < 223 )
	  // 1饹ΣɥåȤʣ̤ʤ ( cmd < 223 )
	  unsigned short n;
	  /*
	    unsigned short* wp = (unsigned short*)imageData;
	    wp -= (cmd < 223)? 1 : 320;
	    unsigned short cpy = *wp;
	    */
	  unsigned char* wp=imageData;
	  wp -= ((cmd < 223)? 1 : 320)*2;
	  const unsigned char low=*wp;
	  const unsigned char hi=*(wp+1);
	  switch (cmd)
	    {
	    case 208:
	    case 223:
	      /*
	       *imageData++ = cpy & 0xff;
	       *imageData++ = cpy & 0xff;
	       */
	      *imageData++=low;
	      *imageData++=low;
	      break;
	    case 209:
	    case 224:
	      /*
	       *imageData++ = cpy >> 8;
	       *imageData++ = cpy >> 8;
	       */
	      *imageData++=hi;
	      *imageData++=hi;
	      break;
	    case 210:
	    case 225:
	      /*
	       *imageData++ = cpy >> 8;
	       *imageData++ = cpy & 0xff;
	       */
	      *imageData++ =hi;
	      *imageData++ =low;
	      break;
	    case 211:
	    case 226:
	      n = getNibble(nakDataSrc, nibble);
	      //	    *imageData++ = cpy & 0xff;
	      *imageData++ =low;
	      *imageData++ = lpBuffer1[n];
	      break;
	    case 212:
	    case 227:
	      n = getNibble(nakDataSrc, nibble);
	      //	    *imageData++ = cpy & 0xff;
	      *imageData++ =low;
	      *imageData++ = lpBuffer2[n];
	      break;
	    case 213:
	    case 228:
	      //	    *imageData++ = cpy & 0xff;
	      *imageData++ =low;
	      *imageData++ = *nakDataSrc++;
	      break;
	    case 214:
	    case 229:
	      n = getNibble(nakDataSrc, nibble);
	      //	    *imageData++ = cpy >> 8;
	      *imageData++ =hi;
	      *imageData++ = lpBuffer1[n];
	      break;
	    case 215:
	    case 230:
	      n = getNibble(nakDataSrc, nibble);
	      //	    *imageData++ = cpy >> 8;
	      *imageData++ =hi;
	      *imageData++ = lpBuffer2[n];
	      break;
	    case 216:
	    case 231:
	      //	    *imageData++ = cpy >> 8;
	      *imageData++ =hi;
	      *imageData++ = *nakDataSrc++;
	      break;

	    case 217:
	    case 232:
	      n = getNibble(nakDataSrc, nibble);
	      *imageData++ = lpBuffer1[n];
	      //	    *imageData++ = cpy >> 8;
	      *imageData++ =hi;
	      break;
	    case 218:
	    case 233:
	      n = getNibble(nakDataSrc, nibble);
	      *imageData++ = lpBuffer2[n];
	      //	    *imageData++ = cpy >> 8;
	      *imageData++ =hi;
	      break;
	    case 219:
	    case 234:
	      *imageData++ = *nakDataSrc++;
	      //	    *imageData++ = cpy >> 8;
	      *imageData++ =hi;
	      break;

	    case 220:
	    case 235:
	      n = getNibble(nakDataSrc, nibble);
	      *imageData++ = lpBuffer1[n];
	      //	    *imageData++ = cpy & 0xff;
	      *imageData++ =low;
	      break;
	    case 221:
	    case 236:
	      n = getNibble(nakDataSrc, nibble);
	      *imageData++ = lpBuffer2[n];
	      //	    *imageData++ = cpy & 0xff;
	      *imageData++ =low;
	      break;
	    case 222:
	    case 237:
	      *imageData++ = *nakDataSrc++;
	      //	    *imageData++ = cpy & 0xff;
	      *imageData++ =low;
	      break;
	    }
	}
      else
	{
	  unsigned short n1;
	  switch (cmd)
	    {
	    case 238:
	      *imageData++ = lpBuffer1[((*nakDataSrc) & 0x0f)];
	      *imageData++ = lpBuffer1[((*nakDataSrc++) >> 4)];
	      break;
	    case 239:
	      *imageData++ = lpBuffer2[((*nakDataSrc) & 0x0f)];
	      *imageData++ = lpBuffer1[((*nakDataSrc++) >> 4)];
	      break;
	    case 240:
	      *imageData++ = lpBuffer1[((*nakDataSrc) & 0x0f)];
	      *imageData++ = lpBuffer2[((*nakDataSrc++) >> 4)];
	      break;
	    case 241:
	      *imageData++ = lpBuffer2[((*nakDataSrc) & 0x0f)];
	      *imageData++ = lpBuffer2[((*nakDataSrc++) >> 4)];
	      break;
	    case 242:	// ɤ򤽤Τޤ޽񤭹
	      *imageData++ = *nakDataSrc++;
	      *imageData++ = *nakDataSrc++;
	      break;

	    case 243:	// ХȤΥɥ쥹*2­
	      imageData += *nakDataSrc;
	      imageData += *nakDataSrc++;
	      break;
	    case 244:	// ɤΥɥ쥹­
	      //imageData += *((unsigned short*)nakDataSrc);
	      imageData += *(nakDataSrc)+(*(nakDataSrc+1) << 8);
	      nakDataSrc += 2;
	      break;

	    case 245:
	      *imageData++ = lpBuffer1[getNibble(nakDataSrc, nibble)];
	      imageData++;
	      break;
	    case 246:
	      *imageData++ = lpBuffer2[getNibble(nakDataSrc, nibble)];
	      imageData++;
	      break;
	    case 247:
	      *imageData++ = *nakDataSrc++;
	      imageData++;
	      break;
	    case 248:
	      imageData++;
	      *imageData++ = lpBuffer1[getNibble(nakDataSrc, nibble)];
	      break;
	    case 249:
	      imageData++;
	      *imageData++ = lpBuffer2[getNibble(nakDataSrc, nibble)];
	      break;
	    case 250:
	      imageData++;
	      *imageData++ = *nakDataSrc++;
	      break;

	    case 251:
	      n1 = lpBuffer1[getNibble(nakDataSrc, nibble)];
	      *imageData++ = n1;
	      *imageData++ = n1;
	      break;
	    case 252:
	      n1 = lpBuffer2[getNibble(nakDataSrc, nibble)];
	      *imageData++ = n1;
	      *imageData++ = n1;
	      break;
	    case 253:
	      n1 = *nakDataSrc++;
	      *imageData++ = n1;
	      *imageData++ = n1;
	      break;
	    case 255:
				// 裱饦ɽλʺ磵饦ɤޤǡ
	      if (++c == 5) return;
	      nibble = 255;
	      imageDataStart += 4000 * 16;
	      imageData = imageDataStart;
	      break;
	    }
	}
    }
}
